package com.jclark.xml.sax;

import com.jclark.xml.parse.*;

/**
 * An implementation of SAX on top of the com.jclark.xml.parse package.
 */
public class Driver implements org.xml.sax.Parser {
  private org.xml.sax.EntityHandler entityHandler;
  private org.xml.sax.DocumentHandler documentHandler;
  private org.xml.sax.ErrorHandler errorHandler;

  public void setEntityHandler(org.xml.sax.EntityHandler handler) {
    this.entityHandler = handler;
  }

  public void setDocumentHandler(org.xml.sax.DocumentHandler handler) {
    this.documentHandler = handler;
  }

  public void setErrorHandler(org.xml.sax.ErrorHandler handler) {
    this.errorHandler = handler;
  }

  public void parse(String publicId, String systemId) throws java.lang.Exception {
    org.xml.sax.ErrorHandler errorHandler = this.errorHandler;
    Bridge bridge = new Bridge(documentHandler, entityHandler);
    Parser parser = new ParserImpl();
    parser.setApplication(bridge);
    parser.setEntityManager(bridge);

    try {
      parser.parseDocument(bridge.open(systemId, null, publicId));
    }
    catch (WrapperException e) {
      throw e.getWrapped();
    }
    catch (NotWellFormedException e) {
      if (errorHandler == null)
	throw new org.xml.sax.XmlException(e.getMessageWithoutLocation(),
					   e.getEntityLocation(),
					   e.getLineNumber(),
					   e.getColumnNumber());
      else
	errorHandler.fatal(e.getMessageWithoutLocation(),
			   e.getEntityLocation(),
			   e.getLineNumber(),
			   e.getColumnNumber());
    }
  }
}
